
/***************************************************************************

Copyright (c) Microsoft Corporation. All rights reserved.
This code is licensed under the Visual Studio SDK license terms.
THIS CODE IS PROVIDED *AS IS* WITHOUT WARRANTY OF
ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING ANY
IMPLIED WARRANTIES OF FITNESS FOR A PARTICULAR
PURPOSE, MERCHANTABILITY, OR NON-INFRINGEMENT.

***************************************************************************/

using System;
using System.Runtime.InteropServices;
using System.CodeDom.Compiler;
using System.CodeDom;
using System.IO;
using System.Text;
using System.Xml;
using System.Xml.Schema;
using Microsoft.Win32;
using Microsoft.VisualStudio.Shell;
using VSLangProj80;
using Itcast.JSMin.Helpers;
using Itcast.JSMin.FileGenerators;
using Itcast.JSMin;
using Itcast.JSMin.OptionPages;
using System.Reflection;

namespace ItcastJSMin
{
    /// <summary>
    /// This is the generator class. 
    /// When setting the 'Custom Tool' property of a C#, VB, or J# project item to "XmlClassGenerator", 
    /// the GenerateCode function will get called and will return the contents of the generated file 
    /// to the project system
    /// </summary>
    [ComVisible(true)]
    [Guid("52B316AA-1997-4c81-9969-83604C09EEB4")]
    [CodeGeneratorRegistration(typeof(JSMinGenerator),"C# JSMin Generator",vsContextGuids.vsContextGuidVCSProject,GeneratesDesignTimeSource=true)]
    [CodeGeneratorRegistration(typeof(JSMinGenerator), "VB JSMin Generator", vsContextGuids.vsContextGuidVBProject, GeneratesDesignTimeSource = true)]
    [CodeGeneratorRegistration(typeof(JSMinGenerator), "J# JSMin Generator", vsContextGuids.vsContextGuidVJSProject, GeneratesDesignTimeSource = true)]
    [ProvideObject(typeof(JSMinGenerator))]
    public class JSMinGenerator : BaseCodeGeneratorWithSite
    {
        //The name of this generator (use for 'Custom Tool' property of project item)
        //internal static string name = "XmlClassGenerator";

        /// <summary>
        /// Function that builds the contents of the generated file based on the contents of the input file
        /// </summary>
        /// <param name="inputFileContent">Content of the input file</param>
        /// <returns>Generated file as a byte array</returns>
        protected override byte[] GenerateCode(string inputFileContent)
        {
            //string result = new Minifier().JsMin(inputFileContent)
            string result;
            //ѡҳ
            JSMinOptionPage optionPage = JSMinPackage.Instance._GetDialogPage<JSMinOptionPage>();
            //dll·ΪգʹMinifierĬѹ㷨
            if (string.IsNullOrEmpty(optionPage.PluginPath))
            {
                result = new Minifier().JsMin(inputFileContent);
            }
            else//dll·ΪգʹָĲѹ
            {
                Assembly asm = Assembly.LoadFile(optionPage.PluginPath);//زdll
                if (string.IsNullOrEmpty(optionPage.JSMinClassFullName))
                {
                    throw new Exception("ˡJSMinѹ·򡾲ȫΪ");
                }
                Type type = asm.GetType(optionPage.JSMinClassFullName);//ò
                Object obj = Activator.CreateInstance(type);
                if (obj == null)
                {
                    throw new Exception("" + type+"ʧܣ");
                }
                MethodInfo jsMinMethod = type.GetMethod("JsMin", new Type[] { typeof(string) });//һΪJsMinһstringһstringֵĺ
                if (jsMinMethod == null)
                {
                    throw new Exception("бһΪJsMinһstringһstringֵĺ");
                }
                result = (string)jsMinMethod.Invoke(obj, new object[] { inputFileContent });                
            }
            return Encoding.UTF8.GetBytes(result);
        }

        protected override string GetDefaultExtension()
        {
            return ".min.js";
        }
    }
}