﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.VisualStudio.Shell;
using System.Runtime.InteropServices;
using System.Security.Permissions;
using System.ComponentModel.Design;
using EnvDTE;
using Itcast.JSMin.Helpers;
using ItcastJSMin;
using Itcast.JSMin.OptionPages;

namespace Itcast.JSMin
{
    //f1536ef8-92ec-443c-9ed7-fdadf150da82代表VSConstants.UICONTEXT_SolutionExists
    //也就说当存在一个工程的时候插件被加载
    //因为默认情况下MenuCommandsPackage只有当至少一个菜单项被选中的时候才会被调用，
    //This is the class that Visual Studio will create hen one of the commands will be selected by the use
    //所以我们要使用ProvideAutoLoad来提前加载
    [ProvideLoadKey("Standard", "1.0", "JSMinPackage", "Itcast", 1)]//1表示在Resource.resx中名字为1的为PLK

    [ProvideAutoLoad("{f1536ef8-92ec-443c-9ed7-fdadf150da82}")]
    [PackageRegistration(UseManagedResourcesOnly = true)]
    [DefaultRegistryRoot(@"Microsoft\VisualStudio\9.0Exp")]    
    [Guid("3720181F-216C-4e01-BDC8-F9165AEFFD66")]//插件的Guid
    [ProvideMenuResource(100, 1)]
    [ProvideOptionPage(typeof(JSMinOptionPage), "JSMin", "General", 0, 0, true)]
    [ComVisible(true)]
    public sealed class JSMinPackage : Package
    {
        public static JSMinPackage Instance { get; internal set; }

        [SecurityPermission(SecurityAction.Demand, Flags = SecurityPermissionFlag.UnmanagedCode)]
        protected override void Initialize()
        {
            base.Initialize();
            Instance = this;
            OleMenuCommandService mcs = GetService(typeof(IMenuCommandService)) as OleMenuCommandService;
            if (null != mcs)
            {
                //切换JS压缩的命令
                CommandID toggleCustToolCmdId = new CommandID(Guids.guidToggleCustTool, Guids.cmdidToggleCustToolCommand);
                OleMenuCommand toggleCustToolCmd = new OleMenuCommand(new EventHandler(OnToggleCustToolClick), toggleCustToolCmdId);
                toggleCustToolCmd.BeforeQueryStatus += new EventHandler(toggleCustToolCmd_BeforeQueryStatus);
                mcs.AddCommand(toggleCustToolCmd);
            }
        }

        public T _GetDialogPage<T>() where T:DialogPage
        {
            return (T)GetDialogPage(typeof(T));
        }

        void toggleCustToolCmd_BeforeQueryStatus(object sender, EventArgs e)
        {
            OleMenuCommand command = sender as OleMenuCommand;

            ProjectItem prjItem = IDEUtils.GetDTESingleSelectedItem().ProjectItem;//获得当前选定的ProjectItem
            command.Visible = prjItem.Name.EndsWith(".js");//只有js文件才显示菜单
            bool hasJSMinCustTool = IDEUtils.GetCustomTool(prjItem) == typeof(JSMinGenerator).Name;
            command.Checked = hasJSMinCustTool;//如果ProjectItem上设置了JSMinGenerator的CustomTool，则选中，否则不选中
        }

        void OnToggleCustToolClick(object sender, EventArgs e)
        {
            OleMenuCommand command = sender as OleMenuCommand;
            ProjectItem prjItem = IDEUtils.GetDTESingleSelectedItem().ProjectItem;
            bool hasJSMinCustTool = IDEUtils.GetCustomTool(prjItem) == typeof(JSMinGenerator).Name;//是否设置了JSMinGenerator的CustomTool
            if (hasJSMinCustTool)//切换JSMinGenerator的CustomTool
            {
                IDEUtils.SetCustomTool(prjItem, string.Empty);//清除CustomTool
            }
            else
            {
                IDEUtils.SetCustomTool(prjItem, typeof(JSMinGenerator).Name);
            }            
        }
    }

    static class  Guids
    {
        public static Guid guidItcastJSMinMenuGroup = new Guid("E65813C5-F3FB-401c-8BF5-977BA490ECD6");
        public static Guid guidToggleCustTool = new Guid("FEE99495-2F08-445e-B18B-06E28A5A891D");
        public static int cmdidToggleCustToolCommand = 0x2012;
    }
}
